clc;
clear;
%% Read Weather data and Operationa Limits to Workspace
tic
run('ReadWeatherandOpLim');
%Weather=zeros(22572,11);
iterations = 40;
frekvenser=1;

%% Define variables
OperationsPerf = zeros(iterations,frekvenser);
numCanc_all = zeros(iterations,frekvenser);
TimeWOWport = zeros(iterations,frekvenser);
TimeWOWsite = zeros(iterations,frekvenser);
opRequested = zeros(iterations,frekvenser);
OperabilityAcc = zeros(iterations,frekvenser);
Operability_all = zeros(iterations,frekvenser);
TimeWaitonMission = zeros(iterations,frekvenser);
OperationDelayed = zeros(iterations,frekvenser);
index=0;
Headingindex = 4;

%% Run Simulation
for j = 1:frekvenser
    
    index=index+1;
    Frq= j;
    
    for i = 1:iterations
    
    Seed = i;
    
    sim('Model');    % Run simulation  
 
%% Post-Simulation Data Gathering
    
%Number of operations canceled
    numCanc = length(OperationCanceled.Data);
    numCanc_all(i,index)=numCanc;
    
% Waiting on Weather
    if  isempty(WOWsite.Data)==0
    TimeWOWsite(i,index) = WOWsite.Data(length(WOWsite.Data));
    end
    
    if  isempty(WOWport.Data)==0
    TimeWOWport(i,index) = WOWport.Data(length(WOWport.Data));
    end

% Waiting on Mission
    TimeWaitonMission(i,index) = WaitonMission.Data(length(WaitonMission.Data));

% Total number of operations performed
    numOp = NumOpPerformed.Data;
    timeOp = NumOpPerformed.Time;
    opPerformed = numOp(length(numOp));
    OperationsPerf(i,index)=opPerformed;
    
% Operations Requested
    opRequested(i,index) = NumoperationsRequested.Data(length(NumoperationsRequested.Data));

% Operability
    Operability_all(i,index) = OperationsPerf(i,index)/opRequested(i,index)*100;
    
% Delayed Operations
    OperationDelayed(i, index) = length(OpDelayed.Data);
    
% Accumulated Operability
    OperabilityAcc(i, index) = sum(Operability_all(:,index))/i;
    
    
    end
end


%% Post-Simulation Calculation


OperationsPerf_mean = round(mean(OperationsPerf))';
opRequested_mean = round(mean(opRequested))';
numCanc_all_mean = round(mean(numCanc_all))';
TimeWOWsite_mean = round(mean(TimeWOWsite))';
TimeWOWport_mean = round(mean(TimeWOWport))';
TimeWaitonMission_mean = round(mean(TimeWaitonMission))';
OpDelayed_mean = round(mean(OperationDelayed))';

RRO = OperationsPerf_mean/opRequested_mean*100';

    A = zeros(frekvenser,1)+100;


RROT =A - (TimeWOWsite_mean + TimeWOWport_mean)/19970*100;

RRNDO =A - (OpDelayed_mean/OperationsPerf_mean);

toc

